--*******************PHX*************
--@author  Acid_Burn84
--@date  18/07/08
--***********************EDIT BY DantesLS 30.05.2009************


phx_5 = {};

function phx_5.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;
function phx_5:load(xmlFile)

	
	local translationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart2#index"));
    if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end;
	
	

	self.groundParticleSystems1 = {};
    local psName = "vehicle.groundParticleSystem1";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems1, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems2 = {};
    local psName = "vehicle.groundParticleSystem2";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems2, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems3 = {};
    local psName = "vehicle.groundParticleSystem3";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems3, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems4 = {};
    local psName = "vehicle.groundParticleSystem4";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems4, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems5 = {};
    local psName = "vehicle.groundParticleSystem5";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems5, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems6 = {};
    local psName = "vehicle.groundParticleSystem6";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems6, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems7 = {};
    local psName = "vehicle.groundParticleSystem7";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems7, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems8 = {};
    local psName = "vehicle.groundParticleSystem8";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems8, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems9 = {};
    local psName = "vehicle.groundParticleSystem9";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems9, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems10 = {};
    local psName = "vehicle.groundParticleSystem10";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems10, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems11 = {};
    local psName = "vehicle.groundParticleSystem11";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems11, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems12 = {};
    local psName = "vehicle.groundParticleSystem12";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems12, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems13 = {};
    local psName = "vehicle.groundParticleSystem13";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems13, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems14 = {};
    local psName = "vehicle.groundParticleSystem14";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems14, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems15 = {};
    local psName = "vehicle.groundParticleSystem15";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems15, psName, self.rootNode, false, nil, self.baseDirectory)
	
	self.groundParticleSystems16 = {};
    local psName = "vehicle.groundParticleSystem16";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems16, psName, self.rootNode, false, nil, self.baseDirectory)	
   
	self.groundParticleSystems = {};
    local psName = "vehicle.groundParticleSystem";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems, psName, self.components, false, nil, self.baseDirectory)
    self.groundParticleSystemActive = false;

    self.translationMax2 = false;

end;

function phx_5:delete()
end;


function phx_5:mouseEvent(posX, posY, isDown, isUp, button)
end;

function phx_5:keyEvent(unicode, sym, modifier, isDown)
	
	if isDown and sym == Input.KEY_n then
		self.translationMax2 = not self.translationMax2;
	end;	
end;


function phx_5:update(dt)

	if self.attacherVehicle then
	
		self.isExpandedRight = false;
        if self.rotationPartRight ~= nil then
            local x, y, z = getRotation(self.rotationPartRight.node);
            local minRot = self.rotationPartRight.minRot;
            local eps = self.rotationPartRight.touchRotLimit;

            if math.abs(x-minRot[1]) < eps and math.abs(y-minRot[2]) < eps and math.abs(z-minRot[3]) < eps then
                self.isExpandedRight = true;
            end;
        end;
		

		
		if  self.translationMax2 then
	

		
			Utils.setEmittingState(self.groundParticleSystems1, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems2, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems3, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems4, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems5, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems6, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems7, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems8, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems9, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems10, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems11, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems12, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems13, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems14, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems15, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			Utils.setEmittingState(self.groundParticleSystems16, (self.attacherVehicle.lastSpeed*3600 > 2 ));
			
			
			if table.getn(self.cuttingAreas) > 0 then
				local x,y,z = getWorldTranslation(self.cuttingAreas[1].start);
				local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[1].width);
				local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[1].height);
				Utils.updatePloughArea(x, z, x1, z1, x2, z2);
			end;
		
			
		
		end;	
	
		if self.translationMax2 and self.isExpandedRight and self.attacherVehicle.lastSpeed*3600 > 2 then
			if not self.workSoundRunning then
                print("start");
                playSample(self.workSound, 0, 1.6, 0);
                self.workSoundRunning = true;
			end;
		end;
		
		if not self.translationMax2 or not self.isExpandedRight or self.attacherVehicle.lastSpeed*3600 < 2 then
			if self.workSoundRunning then
                print("end");
                stopSample(self.workSound, 0, 1.6, 0);
                self.workSoundRunning = false;
			end;
		
	if self.groundParticleSystemActive then
            self.groundParticleSystemActive = false;
            Utils.setEmittingState(self.groundParticleSystems, false);
			Utils.setEmittingState(self.groundParticleSystems1, false);
			Utils.setEmittingState(self.groundParticleSystems2, false);
			Utils.setEmittingState(self.groundParticleSystems3, false);
			Utils.setEmittingState(self.groundParticleSystems4, false);
			Utils.setEmittingState(self.groundParticleSystems5, false);
			Utils.setEmittingState(self.groundParticleSystems6, false);
			Utils.setEmittingState(self.groundParticleSystems7, false);
			Utils.setEmittingState(self.groundParticleSystems8, false);
			Utils.setEmittingState(self.groundParticleSystems9, false);
			Utils.setEmittingState(self.groundParticleSystems10, false);
			Utils.setEmittingState(self.groundParticleSystems11, false);
			Utils.setEmittingState(self.groundParticleSystems12, false);
			Utils.setEmittingState(self.groundParticleSystems13, false);
			Utils.setEmittingState(self.groundParticleSystems14, false);
			Utils.setEmittingState(self.groundParticleSystems15, false);
			Utils.setEmittingState(self.groundParticleSystems16, false);
		end;
	


        end;
    
    
	
end;
	
	
	if self.translationMax2 ~= nil then
		local x, y, z = getTranslation(self.translationPart2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translationMax2);
        setTranslation(self.translationPart2.node, unpack(newTrans));
	end;
	
	
	


end;

function phx_5:draw()
	
	if self.translationMax2 then
		g_currentMission:addExtraPrintText("Wcisnij N: Podnies");
	else
		g_currentMission:addExtraPrintText("Wcisnij N: Opusc");
	end;
	
end;




